//---------------------------------------------------------------------------
#ifndef encoderH
#define encoderH
//---------------------------------------------------------------------------

#define ENC_SINGLE 1
#define ENC_QUAD 2

typedef unsigned char uchar;

// encoder edges structute
typedef struct{
	double last;
	double first;
	int cnt;
	double freq;
}TEncEdge;

// encoder structute
typedef struct{
	// mode
	int mode;
	// pulses per revolution
	int ppr;
	// treshold
	int ofs;

	// last stereo sample from previous buffer
	uchar smpl[2];

	// encoder edges
	TEncEdge edge[4];

	// int channel levels
	int lev[2];

	// comon
	int dir;
	double freq;
	double rps;
}TEnc;



extern int enc_init(int mode,int ppr,int treshold);
extern int enc_set_ppr(int ppr);
extern int enc_decode(char *data,int count,int srate);
extern int enc_get(TEnc **penc);


#endif
