//---------------------------------------------------------------------------
#ifndef graphH
#define graphH
//---------------------------------------------------------------------------
#include "sys_model.h"


// graph colors
#define GR_BACK 0x00000000u
#define GR_GRID 0x00006000u
#define GR_TRACEA 0x0000EE00u
#define GR_TRACEB 0x00EE3300u
#define GR_TRACEC 0x00EEEE00u
#define GR_TRACED 0x0022AAEEu
#define GR_GRIDN 8

typedef struct{
	char *data[2];
	int len[2];
	int ready;
	int used;
}TInData;

#define GR_MAX_TRACE 4
#define GR_NO_TRACE (1E-18)
typedef struct{
	double *traces[GR_MAX_TRACE];
	DWORD colors[GR_MAX_TRACE];
	int pos[GR_MAX_TRACE];
	int length;
	double min;
	double max;
	int rate;
}TSpdGraph;


#define PZMAP_TYPE_ZERO 0
#define PZMAP_TYPE_POLE 1
#define PZMAP_SL 1.25
#define PZMAP_PD 5
#define PZMAP_TRI 6
#define PZMAP_AXLBL_DIST 5



extern int enc_graph_init_buffer(void);
extern int enc_graph_close_buffer(void);
extern int enc_graph_fill_buffer(char *data,int count);
extern int enc_graph_draw_wave(TImage *img,int scale);

extern int reg_graph_init(TSpdGraph *buf);
extern int reg_graph_close(TSpdGraph *buf);
extern int reg_graph_config(TSpdGraph *buf,double min,double max,int rate);
extern int reg_graph_add(TImage *img,TSpdGraph *buf,double sample,int id);
extern int reg_graph_grid(TImage *img);
extern int reg_graph_draw_trace(TImage *img,TSpdGraph *buf,int id,DWORD color);
extern int reg_graph_draw_legend(TImage *img,TSpdGraph *buf,TFont *font,int n,char *str[]);


extern void PZ_draw_back(TImage *img,double ss);
extern void PZ_draw_pz(TImage *img,TPoZe *pz,int n,int type,double ss);


#endif
