//---------------------------------------------------------------------------
#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>

#include "graph.h"
#include <Buttons.hpp>
#include <Menus.hpp>
#include <Dialogs.hpp>
#include <ImgList.hpp>
//---------------------------------------------------------------------------

// config.ini
#define INIFILE "config.ini"

// help path
#define HELPFILE "help\\SB_regulator_eng.html"

// record file
#define RECFILE "rec.csv"

// recorder
#define RECOP_NEW 1
#define RECOP_ADD 2
#define RECOP_CLOSE 3
typedef struct{
	char fname[260];
	FILE *fw;
	double time;
	int op;
}TRec;

// 'w' pulser modes
#define WP_PULSE 0
#define WP_STEP 1
#define WP_RAND 2
// steper steps
#define WP_STEPN 4

// custom VCL messages (0x0400 - 0x7FFF)
#define CM_INPUT_REFRESH 0x0400u

class TMForm : public TForm
{
__published:	// IDE-managed Components
	TButton *BtnGo;
	TGroupBox *GBin;
	TImage *ImgEnc;
	TEdit *Efreq;
	TEdit *Erpm;
	TLabel *Label2;
	TLabel *Label3;
	TComboBox *CBscale;
	TLabel *Label1;
	TGroupBox *GBspd;
	TImage *ImgSpd;
	TEdit *EspdMax;
	TUpDown *UDspdMax;
	TLabel *Label4;
	TCheckBox *CBspdSym;
	TComboBox *CBspdRate;
	TLabel *Label5;
	TGroupBox *GBduty;
	TImage *ImgDuty;
	TLabel *Label6;
	TLabel *Label7;
	TEdit *Eduty;
	TComboBox *CBdutyRate;
	TEdit *Epfreq;
	TUpDown *UDfreq;
	TLabel *Label8;
	TEdit *Eppr;
	TUpDown *UDppr;
	TLabel *Label9;
	TGroupBox *GroupBox1;
	TLabel *Label10;
	TEdit *Eper;
	TUpDown *UDper;
	TComboBox *CBinDevs;
	TComboBox *CBoutDevs;
	TLabel *Label11;
	TLabel *Label12;
	TLabel *Label13;
	TComboBox *CBsrate;
	TLabel *Label14;
	TEdit *Eodel;
	TUpDown *UDodel;
	TTrackBar *TBpwm;
	TLabel *Label15;
	TEdit *Enpwm;
	TUpDown *UDnpwm;
	TSpeedButton *CBrec;
	TGroupBox *GroupBox2;
	TRadioButton *RBman;
	TRadioButton *RBauto;
	TRadioButton *RBautoP;
	TBevel *Bevel1;
	TScrollBar *SBtest;
	TLabel *Label16;
	TEdit *Emanw;
	TUpDown *Udmanw;
	TLabel *Label17;
	TBevel *Bevel2;
	TLabel *Label18;
	TEdit *EregPper;
	TUpDown *UDregPper;
	TLabel *Label19;
	TEdit *EregPpkpk;
	TUpDown *UdregPpkpk;
	TBevel *Bevel3;
	TEdit *EregSk;
	TLabel *Label20;
	TEdit *EregSti;
	TLabel *Label21;
	TLabel *Label22;
	TEdit *EregStd;
	TLabel *Label23;
	TEdit *EregSn;
	TLabel *Label24;
	TEdit *EregSbeta;
	TTimer *TimerPulser;
	TGroupBox *GBarx;
	TStaticText *STarxB1;
	TStaticText *STarxB2;
	TLabel *Label25;
	TLabel *Label26;
	TLabel *Label27;
	TStaticText *STarxB3;
	TShape *Shape1;
	TStaticText *STarxA1;
	TLabel *Label28;
	TStaticText *STarxA2;
	TLabel *Label29;
	TStaticText *STarxA3;
	TLabel *Label30;
	TLabel *Label31;
	TBevel *Bevel4;
	TLabel *Label32;
	TEdit *EarxSn;
	TUpDown *UDarxSn;
	TLabel *Label33;
	TEdit *EarxFp;
	TUpDown *UDarxFp;
	TBevel *Bevel5;
	TLabel *Label34;
	TLabel *Label35;
	TEdit *EarxKk;
	TEdit *EarxTk;
	TLabel *Label36;
	TEdit *EarxK;
	TLabel *Label37;
	TEdit *EarxTi;
	TLabel *Label38;
	TEdit *EarxTd;
	TSpeedButton *BtnArxTrace;
	TBitBtn *BtnArxClip;
	TLabel *Label39;
	TEdit *EarxLrnC;
	TUpDown *UDarxLrnC;
	TLabel *Label40;
	TEdit *EarxLrnE;
	TEdit *EznCk;
	TEdit *EznCti;
	TEdit *EznCtd;
	TLabel *Label41;
	TLabel *Label42;
	TLabel *Label43;
	TBitBtn *BtnAutoTune;
	TSpeedButton *BtnAdaptive;
	TBitBtn *BtnArxClipTf;
	TCheckBox *CBarxEnab;
	TStatusBar *SB;
	TLabel *Label44;
	TEdit *EregStt;
	TMainMenu *MM;
	TMenuItem *MMexit;
	TMenuItem *MMhelp;
	TMenuItem *MMabout;
	TBevel *Bevel6;
	TFontDialog *LegendFont;
	TRadioButton *RBautoR;
	TRadioButton *RBautoS;
	TOpenDialog *OD1;
	TLabel *Label45;
	TEdit *Exlim;
	TMenuItem *View1;
	TMenuItem *Help1;
	TMenuItem *MMcpoles;
	TMenuItem *MMmpzmap;
	TBitBtn *BtnArxRst;
	TMenuItem *MMarxStep;
	TMenuItem *N1;
	TCheckBox *CBinv;
	TImageList *ImageList1;
	void __fastcall BtnGoClick(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall EspdMaxChange(TObject *Sender);
	void __fastcall CBspdSymClick(TObject *Sender);
	void __fastcall CBspdRateChange(TObject *Sender);
	void __fastcall SBtestChange(TObject *Sender);
	void __fastcall EpfreqChange(TObject *Sender);
	void __fastcall CBdutyRateChange(TObject *Sender);
	void __fastcall EpprChange(TObject *Sender);
	void __fastcall TBpwmChange(TObject *Sender);
	void __fastcall EnpwmKeyPress(TObject *Sender, char &Key);
	void __fastcall EregPperChange(TObject *Sender);
	void __fastcall TimerPulserTimer(TObject *Sender);
	void __fastcall RBautoClick(TObject *Sender);
	void __fastcall RBautoPClick(TObject *Sender);
	void __fastcall RBmanClick(TObject *Sender);
	void __fastcall EarxFpChange(TObject *Sender);
	void __fastcall EarxSnKeyPress(TObject *Sender, char &Key);
	void __fastcall EregSkKeyPress(TObject *Sender, char &Key);
	void __fastcall EznCkKeyPress(TObject *Sender, char &Key);
	void __fastcall BtnAutoTuneClick(TObject *Sender);
	void __fastcall BtnArxClipClick(TObject *Sender);
	void __fastcall BtnArxClipTfClick(TObject *Sender);
	void __fastcall CBarxEnabClick(TObject *Sender);
	void __fastcall EarxLrnEKeyPress(TObject *Sender, char &Key);
	void __fastcall BtnAdaptiveClick(TObject *Sender);
	void __fastcall MMexitClick(TObject *Sender);
	void __fastcall MMaboutClick(TObject *Sender);
	void __fastcall MMhelpClick(TObject *Sender);
	void __fastcall CBrecClick(TObject *Sender);
	void __fastcall RBautoRClick(TObject *Sender);
	void __fastcall RBautoSClick(TObject *Sender);
	void __fastcall ImgEncDblClick(TObject *Sender);
	void __fastcall ImgSpdDblClick(TObject *Sender);
	void __fastcall ImgDutyDblClick(TObject *Sender);
	void __fastcall MMcpolesClick(TObject *Sender);
	void __fastcall MMmpzmapClick(TObject *Sender);
	void __fastcall BtnArxRstClick(TObject *Sender);
	void __fastcall MMarxStepClick(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall CBinvClick(TObject *Sender);
	void __fastcall EmanwKeyPress(TObject *Sender, char &Key);
private:	// User declarations
public:		// User declarations
	__fastcall TMForm(TComponent* Owner);

	// refresh message
	void TMForm::InputRefresh(TMessage msg);

	// other methods
	int TMForm::key_press_float(char &Key);
	double TMForm::edit_to_float(TEdit *edit,double min,double max,double def,char *fmt);
	void TMForm::set_manual_PID(void);
	void TMForm::set_auto_zn_PID(void);
	void TMForm::set_idn_limits(void);
	void TMForm::print_PID_config(double k,double ti,double td);
	int TMForm::text2clip(char *str);

	// ini files
	void TMForm::LoadIni(TIniFile *ini);
	void TMForm::SaveIni(TIniFile *ini);
  
	// paths
	AnsiString apppath;
	AnsiString helppath;

	// graphs
	TSpdGraph spd,duty;

	// 'w' pulser
	int wp_mode;
	int wp_step;

	// ini
	TIniFile *cini;

	// message mapping
	BEGIN_MESSAGE_MAP
		MESSAGE_HANDLER(CM_INPUT_REFRESH,TMessage,InputRefresh)
	END_MESSAGE_MAP(TForm)

};
//---------------------------------------------------------------------------
extern PACKAGE TMForm *MForm;
//---------------------------------------------------------------------------
#endif
