//---------------------------------------------------------------------------
#ifndef regulatorH
#define regulatorH
//---------------------------------------------------------------------------

typedef struct{
	int man;
	int lim;
	double w;
	double T;
	double sum;
	double dif;
	double x;
	double k;
	double Ti;
	double Td;
	double N;
	double beta;
	double Tt;
	double sym;
}TReg;

extern void reg_init(int T);
extern void reg_set_PID(double k,double Ti,double Td);
extern void reg_set_PID_ext(double k,double Ti,double Td,double N,double beta,double Tt);
extern void reg_set_w(double w);
extern void reg_get_w(double *w);
extern void reg_get_x(double *x);
extern int reg_get_x_limit(void);
extern void reg_get_T(double *Ts);
extern void reg_set_man(int man,double duty);
extern int reg_get_man(void);
extern void reg_set_limit(int sym);
extern int reg_get_limit(void);
extern void reg_update(double y,double *x);



#endif

