//---------------------------------------------------------------------------
// Sound Blaster PID regulator experiment - application initializator
//---------------------------------------------------------------------------
// Experimental Sound Blaster PID regulator. It uses SB as an input/output
// interface to the process to be controlled. This demo is designed as
// a speed loop for DC motors with with PWM control and rotary encoder
// feedback but it can be easily converted to any other kind of input/ouput
// format.
// Regulator uses beta-I-PD topology for a controller, variable step
// Steepest-Descent algorithm for system identification and Ziegler-Nichols
// method for auto-tuning.
// For more details follow function comments and visit project www.
//
// License:
// This code can be used in any project but it was designed only for learning
// purposes so author is not responsible for its proper function!
//
// (c) 2012, Stanislav Maslan, s.maslan@seznam.cz
// http://elektronika.kvalitne.cz/SW/SB_regulator.html
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------
USEFORM("main.cpp", MForm);
USEFORM("PZ_form.cpp", PZForm);
USEFORM("MPZ_form.cpp", MPZForm);
USEFORM("MS_form.cpp", MSForm);
USEFORM("AB_form.cpp", AForm);
//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
	try
	{
		Application->Initialize();
		Application->Title = "Sound Blaster PSD regulator";
		Application->CreateForm(__classid(TMForm), &MForm);
		Application->CreateForm(__classid(TAForm), &AForm);
		Application->CreateForm(__classid(TPZForm), &PZForm);
		Application->CreateForm(__classid(TMPZForm), &MPZForm);
		Application->CreateForm(__classid(TMSForm), &MSForm);
		Application->Run();
	}
	catch (Exception &exception)
	{
		Application->ShowException(&exception);
	}
	catch (...)
	{
		try
		{
			throw Exception("");
		}
		catch (Exception &exception)
		{
			Application->ShowException(&exception);
		}
	}
	return 0;
}
//---------------------------------------------------------------------------
