//---------------------------------------------------------------------------
#ifndef sys_modelH
#define sys_modelH
//---------------------------------------------------------------------------

// lsim modes:
#define LSIM_GEN 0u
#define LSIM_STEP 1u
#define LSIM_PULSE 2u

// pole/zero
typedef struct{
	double re;
	double im;
}TPoZe;

// don't change SYS_N!!!
#define SYS_N 6
// fixed delay (0 or 1)
#define SYS_D 1
typedef struct{
	double w[SYS_N];
	double *X[SYS_N];
	double *T;
	int pmax;
	int n;
	int ppos;
	int itmax;
	double err;
	double Ts;
	int filter;

	double zn_k,zn_ti,zn_td;
	int zn_adapt;

	double th[SYS_N];
	double kp[2];
	TPoZe cpole[3];
	TPoZe mpole[3];
	int mpolen;
	TPoZe mzero[3];
	int mzeron;
	double y_pred;
	double ferr;
	int fcyc;

	int enab;
}TSysId;


extern void sys_idn_init(void);
extern void sys_idn_close(void);
extern void sys_idn_reset(int filter);
extern int sys_idn_config(int pat,double Ts);
extern void sys_idn_limit(int cycles,double error);
extern void sys_idn_limit(int *cycles,double *error);
extern void sys_idn_filter(int len);
extern int sys_idn_update(double nx,double ny,double *ypred,double *theta,double *kp);
extern int sys_idn_print_system(char *str,int mode);
extern void sys_idn_state(int enabled);
extern int sys_idn_step(double *th,double x,double *y,int n);
extern int sys_idn_pulse(double *th,double x,double *y,int n);
extern int sys_idn_lsim(double *th,double *x,double *y,int n);
extern int sys_idn_lsim(double *th,double *x,double *y,int n,unsigned int mode);
extern int sys_idn_get_model(double *ypred,double *theta,double *kp,double *err,int *cycles);
extern double sys_idn_get_model_gain(void);
extern int sys_idn_get_critical(double *theta,double *kp,TPoZe *pole);
extern void sys_idn_get_poles(TPoZe *pole);
extern void sys_idn_eval_PZ_solve(double *pl,TPoZe *TPoZe,int *n);
extern void sys_idn_eval_PZ(double *th,TPoZe *poles,int *pn,TPoZe *zeros,int *zn);
extern void sys_idn_get_PZ(TPoZe *poles,int *pn,TPoZe *zeros,int *zn);
extern int sys_idn_adaptive(void);
extern int sys_idn_adaptive(int enabled);
extern void sys_idn_config_zn(double zn_k,double zn_ti,double zn_td);
extern void sys_idn_get_zn(double *k,double *ti,double *td);




#endif
